***************************************************************************
*
* Procedure file: 3DCHECK
*         System: Genscrnx With 3D
*        Version: 1.0
*         Author: Jason M. Landry, CompuServe 74474,3256
*        Company: Exchange Resources, Inc. (Minneapolis, Minnesota)
*      Copyright: 1994, Jason Landry.  All rights reserved.
*
***************************************************************************
*
* 3DCheck - Creates MS Office-like chiseled 3d boxes 
*           when using GENSCRNX by Ken Levy
*
* Place the line "*:SCXDRV5 3DCHECK" before "*:SCXDRV5 3D" in any screen.
* All check boxes will take on a more 3D look.
* Placing "*:3DCB OFF" in the comment snippet of a check box will turn off
* the effect for that screen.

*-SCX Objtypes
#DEFINE cnheader		1
#DEFINE cntext			5
#DEFINE cnline			6
#DEFINE cnbox			7
#DEFINE cnlist			11
#DEFINE cnpushbutton	12
#DEFINE cnradiobutton	13
#DEFINE cncheckbox		14
#DEFINE cnsayget		15
#DEFINE cnpopup			16
#DEFINE cnpicture		17
#DEFINE cnspinner		22
#DEFINE cninvbutton
#DEFINE cnexpression	0
#DEFINE cnprocedure		1
#DEFINE cngetcode		1
#DEFINE ccnull			CHR(0)
#DEFINE cnnormalwt		0
#DEFINE cnboldwt		1

#DEFINE cfssay 1
#DEFINE cfsget 2
#DEFINE cfsmsg 3
#DEFINE cfswhn 4
#DEFINE cfsval 5
#DEFINE cfspic 6
#DEFINE cfsokl 7
#DEFINE cnheader 4
#DEFINE cnscreen 5

DIMENSION headercode(5)
DIMENSION screencode(5)
headercode(1)='show'
headercode(2)='setupcode'
headercode(3)='activate'
headercode(4)='deactivate'
headercode(5)='proccode'
screencode(1)='when'
screencode(2)='valid'
screencode(3)='message'
screencode(4)='error'
screencode(5)='comment'

PRIVATE mwfontface,;
		mwfontsize,;
		mwfontstyle,;
		fmw,;
		fmh,;
		checkproc,;
		clickproc,;
		whenproc,;
		validproc,;
		showproc,;
		objenabled,;
		disabled,;
		initialnum,;
		vpos,;
		hpos,;
		expr,;
		chkfface,;
		chkfsize,;
		chkfstyle,;
		chkname,;
		when,;
		whentype,;
		valid,;
		validtype,;
		message,;
		messtype,;
		tempstr
		
m.mwfontface=fontface
m.mwfontsize=fontsize
m.mwfontstyle="N"
m.fmw=FONTMETRIC(6,m.mwfontface,m.mwfontsize,mwfontstyle)
m.fmh=FONTMETRIC(1,m.mwfontface,m.mwfontsize,mwfontstyle)
DO updthrm WITH "","[WINDOWS] "+LOWER(PROGRAM()),0

SCAN FOR objtype=cncheckbox AND wordsearch("*:3DCB ","comment")<>"OFF"
	DO updthrm WITH "","[WINDOWS] "+LOWER(PROGRAM()),RECNO()/RECCOUNT()*100
	REPLACE comment WITH "*:DELOBJ"
	m.checkproc='check_'+lower(right(sys(2015),4))	&&SYS(2015)
	m.clickproc='click_'+lower(right(sys(2015),4))
	m.whenproc ='when_'+lower(right(sys(2015),4))
	m.validproc='valid_'+lower(right(sys(2015),4))+'()'
	m.showproc='show_'+lower(right(sys(2015),4))
	m.objenabled='m.objen_'+lower(right(sys(2015),4))		&& END SYS(2015)'s
	m.disabled=disabled
	m.initialnum=initialnum
	m.vpos=vpos+1/m.fmh
	m.hpos=hpos-1/m.fmw
	m.expr='"'+SUBSTR(PICTURE,AT(" ",PICTURE)+1,LEN(PICTURE)-AT(" ",PICTURE))
	m.expr=STRTRAN(m.expr,"\<","")	&& eliminate hot key for now.  Next release?
	m.chkfface=fontface
	m.chkfsize=fontsize
	m.chkfstyle="B"
	m.chkname=name
	m.when=when
	m.whentype=whentype
	m.valid=valid
	m.validtype=validtype
	m.message=message
	m.messtype=messtype
	DO CASE
		CASE EMPTY(when)
			m.whenproc=""
		CASE whentype=0
			m.whenproc=when
			m.when=""
		OTHERWISE
			m.whenproc=whenproc+'()'
	ENDCASE

	=insblank(1)
	REPLACE vpos WITH m.vpos,;
		hpos WITH m.hpos,;
		platform WITH "WINDOWS",;
		uniqueid WITH SYS(2019),;
		objtype WITH cnline,;
		HEIGHT WITH .1,;
		STYLE WITH 1,;
		WIDTH WITH 14/m.fmw,;
		comment WITH "*:NO3D",;
		pensize WITH 1,;
		penpat WITH 8,;
		penred WITH 128,;
		penblue WITH 128,;
		pengreen WITH 128,;
		fillred WITH 128,;
		fillblue WITH 128,;
		fillgreen WITH 128
	=duprec(1)
	REPLACE hpos WITH hpos+1/m.fmw,;
		vpos WITH vpos+1/m.fmh,;
		WIDTH WITH 11/m.fmw,;
		penred WITH 0,;
		penblue WITH 0,;
		pengreen WITH 0,;
		fillred WITH 0,;
		fillblue WITH 0,;
		fillgreen WITH 0
	=duprec(1)
	REPLACE HEIGHT WITH 12/m.fmh,;
		WIDTH WITH .1,;
		STYLE WITH 0
	=duprec(1)
	REPLACE hpos WITH hpos-1/m.fmw,;
		vpos WITH vpos-1/m.fmh,;
		HEIGHT WITH 14/m.fmh,;
		penred WITH 128,;
		penblue WITH 128,;
		pengreen WITH 128,;
		fillred WITH 128,;
		fillblue WITH 128,;
		fillgreen WITH 128
	=duprec(1)
	REPLACE vpos WITH vpos+13/m.fmh,;
		hpos WITH hpos+1/m.fmw,;
		HEIGHT WITH 0,;
		WIDTH WITH 13/m.fmw,;
		STYLE WITH 1,;
		penred WITH 255,;
		penblue WITH 255,;
		pengreen WITH 255,;
		fillred WITH 255,;
		fillblue WITH 255,;
		fillgreen WITH 255
	=duprec(1)
	REPLACE hpos WITH hpos+12/m.fmw,;
		vpos WITH vpos-12/m.fmh,;
		HEIGHT WITH 13/m.fmh,;
		WIDTH WITH 0,;
		STYLE WITH 0
	=duprec(1)
	REPLACE hpos WITH m.hpos+2/m.fmw,;
		vpos WITH m.vpos+2/m.fmh,;
		HEIGHT WITH 11/m.fmh,;
		WIDTH WITH 11/m.fmw,;
		STYLE WITH 0,;
		penred WITH 0,;
		penblue WITH 0,;
		pengreen WITH 0,;
		fillred WITH 255,;
		fillblue WITH 255,;
		fillgreen WITH 255,;
		objtype WITH cnbox,;
		penpat WITH 0,;
		STYLE WITH 0,;
		fillpat WITH 1,;
		objcode WITH 4,;
		comment WITH comment+m.cr_lf+"*:CLICK "+m.clickproc
	=duprec(1)
	REPLACE hpos WITH m.hpos+19/m.fmw,;
		vpos WITH m.vpos+1/m.fmh,;
		fontface WITH "MS Sans Serif",;
		fontsize WITH 9,;
		fontstyle WITH 1,;
		HEIGHT WITH 1,;
		WIDTH WITH 5,;
		expr WITH m.expr,;
		objtype WITH 5,;
		objcode WITH 0,;
		penred WITH 0,;
		penblue WITH 0,;
		pengreen WITH 0,;
		fillred WITH -1,;
		fillblue WITH -1,;
		fillgreen WITH -1
	=duprec(1)
	REPLACE hpos WITH m.hpos+18/m.fmw,;
		vpos WITH m.vpos+1/m.fmh,;
		name WITH "m."+SYS(2015),;
		WIDTH WITH TXTWIDTH(SUBSTR(m.expr,2,LEN(m.expr)-2),chkfface,chkfsize,chkfstyle)+3/m.fmw,;
		HEIGHT WITH 1.1,;
		objtype WITH 20,;
		objcode WITH 1,;
		PICTURE WITH '"@*IHN"',;
		penred WITH -1,;
		penblue WITH -1,;
		pengreen WITH -1,;
		fillred WITH -1,;
		fillblue WITH -1,;
		fillgreen WITH -1,;
		valid WITH IIF(!EMPTY(m.validproc),"="+m.validproc+m.cr_lf,'');
		when WITH 'IF !'+objenabled+m.cr_lf+'RETURN .F.'+m.cr_lf+'ELSE'+m.cr_lf+IIF(!EMPTY(m.whenproc),;
			'RETURN '+whenproc,'RETURN .T.')+m.cr_lf+'ENDIF'+m.cr_lf,;
		validtype WITH 1,;
		whentype WITH 1,;
		messtype WITH m.messtype,;
		message WITH m.message
	R=RECNO()

	GO TOP

	REPLACE proccode WITH proccode +m.cr_lf+;
		"FUNCTION "+m.clickproc+m.cr_lf+;
		"IF "+m.objenabled+IIF(!EMPTY(m.whenproc)," AND "+m.whenproc,"")+m.cr_lf+;
		"     ="+m.validproc+m.cr_lf+;
		"ENDIF"+m.cr_lf
	IF '()'$m.whenproc
		REPLACE proccode WITH proccode+m.cr_lf+;
			"FUNCTION "+STRTRAN(whenproc,'()','')+m.cr_lf+m.when+m.cr_lf
	ENDIF

	REPLACE proccode WITH proccode+m.cr_lf+;
		"FUNCTION "+strtran(validproc,"()","")+m.cr_lf+;
			"PRIVATE valres"+m.cr_lf+;
			"valres=.t."+m.cr_lf+;
			IIF(m.validtype=0,"valres="+m.valid,m.valid)+m.cr_lf+;
			"IF !(TYPE('m.valres')<>'L' OR !m.valres))"+m.cr_lf+;
			"     "+ALLTRIM(m.chkname)+"=IIF(TYPE('"+m.chkname+"')='N',MOD("+m.chkname+"+1,2),!"+ALLTRIM(m.chkname)+")"+m.cr_lf+;
			"     ="+showproc+"()"+m.cr_lf+;
			"ENDIF"+m.cr_lf+;
			"RETURN valres"
	
	tempstr=m.cr_lf+m.cr_lf+;
		"FUNCTION "+showproc+m.cr_lf+;
		"PARAMETER argc"+m.cr_lf+;
		"IF PARAMETERS()=0"+m.cr_lf+;
		"     argc=''"+m.cr_lf+;
		"ENDIF"+m.cr_lf+;
		"argc=ALLTRIM(argc)"+m.cr_lf+;
		"DO CASE"+m.cr_lf+;
		"      CASE LEFT(argc,4)='ENAB'"+m.cr_lf+;
		"          "+m.objenabled+"=.t."+m.cr_lf+;
		"      CASE LEFT(argc,4)='DISA'"+m.cr_lf+;
		"          "+m.objenabled+"=.f."+m.cr_lf+;
		"      CASE LEFT(argc,4)='PROM'"+m.cr_lf+;
		"          * - figure out prompt stuff later"+m.cr_lf+;
		"ENDCASE"+m.cr_lf
		
	tempstr=tempstr+"IF (TYPE('"+m.chkname+"')='L' AND !"+m.chkname+") OR (TYPE('"+m.chkname+"')='N' AND "+m.chkname+"=0)"+m.cr_lf+;
		"     @"+ALLTRIM(STR(m.vpos+2/m.fmh,7,3))+","+;
		+ALLTRIM(STR(m.hpos+2/m.fmw,7,3))+" FILL TO "+;
		+ALLTRIM(STR(m.vpos+11/m.fmh,7,3))+","+ALLTRIM(STR(m.hpos+11/m.fmw,7,3))+;
		" COLOR (IIF("+m.objenabled+",'RGB(255,255,255,255,255,255)','RGB(128,128,128,-1,-1,-1)'))"+m.cr_lf+;
		"ELSE"+m.cr_lf+;
		"    @"+ALLTRIM(STR(m.vpos+2/m.fmh,7,3))+","+;
		+ALLTRIM(STR(m.hpos+2/m.fmw,7,3))+" SAY LOCFILE(IIF("+m.objenabled+",'X2.BMP','X3.BMP'))"+;
		" BITMAP"+m.cr_lf+;
		"ENDIF"+m.cr_lf+;
		" @"+ALLTRIM(STR(m.vpos+1/m.fmh,7,3))+","+ALLTRIM(STR(m.hpos+19/m.fmw,7,3))+" SAY "+;
		m.expr+" COLOR (IIF("+m.objenabled+",'RGB(0,0,0,,,)','RGB(128,128,128,,,)'))"+;
		"FONT '"+m.chkfface+"',"+ALLTRIM(STR(chkfsize))+" STYLE '"+m.chkfstyle+"'"

	
	REPLACE proccode WITH proccode+tempstr

	REPLACE setupcode WITH setupcode+m.cr_lf+m.objenabled+'='+IIF(m.disabled,".F.",".T.")+;
		m.cr_lf+"IF TYPE('"+m.chkname+"')='U'"+m.cr_lf+"     "+m.chkname+"="+ALLTRIM(STR(m.initialnum))+m.cr_lf+"ENDIF"
	REPLACE SHOW WITH SHOW+m.cr_lf+"DO "+m.showproc, showtype WITH 1

	* Search for SHOW GET commands and update with new code.
	FOR i=1 TO ALEN(headercode)
		j=findsget(headercode(i))
		DO WHILE j>0
			k=LEN(m.chkname)+9	&& 'SHOW GET '
			REPLACE (headercode(i)) WITH STUFF(EVAL(headercode(i)),j,k,'='+m.showproc+'([')+m.cr_lf
			k=j+AT(m.cr_lf,SUBSTR(EVAL(headercode(i)),j))-1
			REPLACE (headercode(i)) WITH STUFF(EVAL(headercode(i)),k,0,'])')
			j=findsget(headercode(i))
		ENDDO
	ENDFOR
	SKIP
	SCAN REST
		FOR i=1 TO ALEN(screencode)
			j=findsget(screencode(i))			
			DO WHILE j>0
				k=LEN(m.chkname)+9	&& 'SHOW GET '
				REPLACE (screencode(i)) WITH STUFF(EVAL(screencode(i)),j,k,'='+m.showproc+'([')+m.cr_lf
				k=j+AT(m.cr_lf,SUBSTR(EVAL(screencode(i)),j))-1
				REPLACE (screencode(i)) WITH STUFF(EVAL(screencode(i)),k,0,'])')
			j=findsget(screencode(i))
			ENDDO
		ENDFOR
	ENDSCAN
	GO R

ENDSCAN
GO TOP
REPLACE setupcode WITH setupcode+m.cr_lf+"_lastobj=0"
GO BOTTOM
DO updthrm WITH "","[WINDOWS] "+LOWER(PROGRAM()),100

FUNCTION findsget
PARAMETER snippet
PRIVATE strippedvar
m.strippedvar=""
IF "."$m.chkname
	m.strippedvar=SUBSTR(m.chkname,AT(".",m.chkname)+1)
ENDIF
RETURN MAX(ATC('SHOW GET '+m.chkname+' ',EVAL(snippet)+' '),;
	ATC('SHOW GET '+m.chkname+m.cr_lf,EVAL(snippet)+' '),;
	IIF(empty(strippedvar),0,MAX(ATC('SHOW GET '+m.strippedvar+' ',EVAL(snippet)+' '),;
	ATC('SHOW GET '+m.strippedvar+m.cr_lf,EVAL(snippet)+' '))))